####################
#################### Numeric parameters
####################

MILLISECOND      1
SECOND           1000 * MILLISECOND
MINUTE           60 * SECOND

# 1 round = 1 ms
STEP_GOSSIP      1
#STEP_OBS         1 * SECOND
STEP_OBS         10

# From FC21 gossip ethereum
NETWORK_SIZE     22982
DENSITY          1.0 * 328 / NETWORK_SIZE

# Updates
SCENARIO         2
VARIABLES        1
SOURCES          10
END_TIME         10 * SECOND

# Gossip
FANOUT           8

# RPS
STEP_RPS         10 * MINUTE
RPS_VIEW_SIZE    FANOUT * FANOUT

# PMF random sampler
COMPUTATION_TIMEOUT  10 * MINUTE
NB_THREADS_FOR_INIT  8

# Block delay multiplier (eg, 0.5 produces blocks twice faster)
DELAY_MULTIPLIER     0.01


####################
#################### Non-numeric parameters
####################

#random.seed                         1234567890

include.init                        sch prim pmfhelper pmfsrc pmflatency pmfdegree
#include.control                     obs prps
include.control                     obs

init.sch.protocol                   dup
init.prim.protocol                  dup
#init.src.protocol                   dup
init.pmfsrc.protocol                dup
init.pmfdegree.protocol             dup
#control.prps.protocol               dup
control.obs.protocol                dup

# Possible values: p s all
init.pmfsrc.sourceClass             p

# Can be a path relative to the dir containing this cfg
init.pmfhelper.datasetDir           ../../blockchain_datasets/


####################
#################### Sources
####################

init.pmfsrc                         PMFMinerSetter
init.pmfsrc.sources                 SOURCES
init.pmfsrc.variables               VARIABLES
init.pmfsrc.delayFile               block_delay_pmf.csv
init.pmfsrc.minerFile               miners_pmf.csv
init.pmfsrc.delayMultiplier         DELAY_MULTIPLIER

#init.src                            SourceSetter
#init.src.sources                    SOURCES
#init.src.variables                  VARIABLES
#init.src.delay                      DELAY_UPDATES


####################
#################### Latency
####################

init.pmflatency                     PMFLatencyTransport
init.pmflatency.latencyFile         kiffer_latency_pmf.csv
protocol.transport                  PMFLatencyTransport
protocol.transport.latencyFile      kiffer_latency_pmf.csv

#protocol.transport                  UniformRandomTransport
#protocol.transport.mindelay         STEP_OBS
#protocol.transport.maxdelay         STEP_OBS


####################
#################### Topology
####################

init.pmfdegree                      PMFOutdegreeSetter
init.pmfdegree.degreeFile           outdegree_pmf.csv
init.pmfdegree.linkableP            neighboursP
init.pmfdegree.linkableS            neighboursS

#control.prps                        PriorityRandomPeerSampler
#control.prps.step                   STEP_RPS
#control.prps.viewSize               RPS_VIEW_SIZE
#control.prps.protocol               dup
#control.prps.linkableP              neighboursP
#control.prps.linkableS              neighboursS
#control.prps.alpha                  0
#control.prps.beta                   0


####################
#################### Priority gossip
####################

init.prim                           PrimarySetter
init.prim.density                   DENSITY

protocol.dup                        PriorityGossipDuplicate
protocol.dup.step                   STEP_GOSSIP
protocol.dup.linkableP              neighboursP
protocol.dup.linkableS              neighboursS
protocol.dup.transport              transport
protocol.dup.fanout                 FANOUT
protocol.dup.scenario               SCENARIO
protocol.dup.tagsActivated          true
protocol.dup.dupSendP               1
protocol.dup.dupSendS               2

protocol.neighboursS                NeighboursLinkable


####################
#################### Common/Others
####################

simulation.endtime                  END_TIME
network.size                        NETWORK_SIZE

init.sch                            CDScheduler

init.pmfhelper                      PMFHelper
init.pmfhelper.nbThreads            NB_THREADS_FOR_INIT
init.pmfhelper.timeout              COMPUTATION_TIMEOUT

control.obs                         Observer
control.obs.step                    1
control.obs.stepManual              STEP_OBS

protocol.neighboursP                NeighboursLinkable
